#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_pipe1_mp_xi4.py">
#<abstract4xi abstract = "tests pipes and queues"/>
#<refer4xi reference = "DragonXi"/>
#<verify4xi verification = "10" target = "pipe4xi.py"/>
#<contextualize4xi context = "queue4xi.py; forkingpickler4xi.py; popen4xi.py; current_process4xi.py"/>
#<synopsize4xi synopsis = "
#   The Pipe4Xi() function returns a pair of connection objects connected by a pipe which by default is duplex (two-way). 
#   The two connection objects returned by Pipe4Xi() represent the two ends of the pipe. 
#   Each connection object has send() and recv() methods (among others). 
#   Data in a pipe may become corrupted if two processes (or threads) try to read from or write to the same end of the pipe at the same time. 
#   There is no risk of corruption from processes using different ends of the pipe at the same time.
#
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # most-common ones
    pass         
except:
    pass
try:                 # rare ones
    pass         
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.process import Process
    from multiprocessing.queues  import Queue
    from multiprocessing.connection import Pipe
except:
    pass
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
try:
    # -------------------------------------------------------------------------------------------------
    # Dragon2Xi imports                               
    # -------------------------------------------------------------------------------------------------
    from process2xi import Process2Xi
    from queue2xi  import Queue2Xi
    from pipe2xi import Pipe2Xi

except:
    pass  
    
   
# -------------------------------------------------------------------------------------------------
# Dragon4Xi imports                               
# -------------------------------------------------------------------------------------------------
from process4xi import Process4Xi
from queue4xi  import Queue4Xi
from pipe4xi import Pipe4Xi

from current_process4xi import CurrentProcess4Xi
from current_process4xi import init_all_current_process4xi
from current_process4xi import set_all_current_process4xi
from current_process4xi import get_all_current_process4xi
from current_process4xi import get_one_current_process4xi
from current_process4xi import value_current_process4xi
#1
from current_process4xi import init_current_process4xi
from current_process4xi import get_current_process4xi
from current_process4xi import set_current_process4xi
#2
from current_process4xi import init_inheriting_current_process4xi
from current_process4xi import get_inheriting_current_process4xi
from current_process4xi import set_inheriting_current_process4xi
#3
from current_process4xi import init_authkey_current_process4xi
from current_process4xi import get_authkey_current_process4xi
from current_process4xi import set_authkey_current_process4xi
#4
from current_process4xi import init_identity_current_process4xi
from current_process4xi import get_identity_current_process4xi
from current_process4xi import set_identity_current_process4xi
#5
from current_process4xi import init_name_current_process4xi
from current_process4xi import get_name_current_process4xi
from current_process4xi import set_name_current_process4xi
#6
from current_process4xi import init_counter_current_process4xi
from current_process4xi import get_counter_current_process4xi
from current_process4xi import set_counter_current_process4xi
#7                             
from current_process4xi import init_daemonic_current_process4xi
from current_process4xi import get_daemonic_current_process4xi
from current_process4xi import set_daemonic_current_process4xi
#8                             
from current_process4xi import init_tempdir_current_process4xi
from current_process4xi import get_tempdir_current_process4xi
from current_process4xi import set_tempdir_current_process4xi
#9
from current_process4xi import add_child_current_process4xi
from current_process4xi import discard_child_current_process4xi
from current_process4xi import get_children_current_process4xi
#10                             
from current_process4xi import init_manager_server_current_process4xi
from current_process4xi import get_manager_server_current_process4xi
from current_process4xi import set_manager_server_current_process4xi

from print4xi import Print4Xi
from print4xi import print4xi
from time4xi import time4xi
from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi     

#"
#/>
from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi globals                        
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

# -------------------------------------------------------------------------------------------------
# trace ones
# -------------------------------------------------------------------------------------------------

global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# state ones
# -------------------------------------------------------------------------------------------------

global ack4queues
global nack4queues

global ack4pipes
global nack4pipes

global ack4process
global nack4process

global ack4process
global nack4process

global ack4start
global nack4start   
        
global ack4run
global nack4run

# -------------------------------------------------------------------------------------------------
# sense ones
# -------------------------------------------------------------------------------------------------

global queue2xi
global pipe2xi_consumer_channel
global pipe2xi_publisher_channel
global process2xi

# -------------------------------------------------------------------------------------------------
# reason ones
# -------------------------------------------------------------------------------------------------

global queue4xi
global pipe4xi_consumer_channel
global pipe4xi_publisher_channel
global process4xi

# -------------------------------------------------------------------------------------------------
# ace ones
# -------------------------------------------------------------------------------------------------

global queue8xi
global pipe8xi_consumer_channel
global pipe8xi_publisher_channel
global process8xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

# -------------------------------------------------------------------------------------------------
# trace ones
# -------------------------------------------------------------------------------------------------


PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
       

# -------------------------------------------------------------------------------------------------
# common ones
# -------------------------------------------------------------------------------------------------

ack4queues = False
nack4queues = True

ack4pipes = False
nack4pipes = True

ack4process = False
nack4process = True

ack4process = False
nack4process = True

ack4start = False
nack4start = True   
 
ack4run = False
nack4run = True

# -------------------------------------------------------------------------------------------------
# sense ones
# -------------------------------------------------------------------------------------------------

queue2xi = None
pipe2xi_consumer_channel = None
pipe2xi_publisher_channel = None
process2xi = None

# -------------------------------------------------------------------------------------------------
# reason ones
# -------------------------------------------------------------------------------------------------
queue4xi = None
pipe4xi_consumer_channel = None
pipe4xi_publisher_channel = None
process4xi = None

# -------------------------------------------------------------------------------------------------
# ace ones
# -------------------------------------------------------------------------------------------------
queue8xi = None
pipe8xi_consumer_channel = None
pipe8xi_publisher_channel = None
process8xi = None

       
       
#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {  
        # 'arbitrary_address4xi': 'NACK4TRACE',
        # 'Connection4Xi': 'NACK4TRACE',
        # 'ConstantConnection4Xi': 'NACK4TRACE',
        # 'get_windows_system4xi': 'NACK4TRACE',
        # 'get_af_inet4xi': 'NACK4TRACE',
        # 'get_af_unix4xi': 'NACK4TRACE',
        # 'get_af_pipe4xi': 'NACK4TRACE',
        # 'ForkingPickler4Xi': 'NACK4TRACE',
        'Pipe4Xi': 'NACK4TRACE', 
        'PipeConnection4Xi': 'NACK4TRACE',
        'Popen4Xi': 'NACK4TRACE',
        'Process4Xi': 'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        '_ConnectionBase4Xi': 'NACK4TRACE'
        }   
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       

           

# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   creates XML files of test_pipe1_mp_xi4
#">                       
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-pipe1-test4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Test-1 of Pipe in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Test-1 of Pipe in Multiprocessing.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-pipe1-test4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Test-1 of Pipe in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Test-1 of Pipe in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-pipe1-test4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Test-1 of Pipe in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Test-1 of Pipe in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
  

# -----------------------------------------------------------------------------------------------------
#<function4xi function = "sense" usage = "
#   SENSE with Dragon4Xi multiprocessing
#"> 
# -----------------------------------------------------------------------------------------------------
       
def sense(target_param, queue_param, pipe_param):
    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    target_xi2 = target_param
    
    print('=' *33)
    print("SENSE: SENSING TARGET: ", target_xi2)
    print('=' *33)
    # Energy
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    queue_xi2 = queue_param
    
    print('~' *33)
    print("SENSE: SENSING QUEUE: ", queue_xi2)
    print('~' *33)
    # <queue4xi.Queue4Xi object at 0x02CBBBD0>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    pipe_publisher_channel_xi2 = pipe_param    
    
    print('~' *33)
    print("SENSE: SENSING PIPE PUBLISHER CHANNEL: ", pipe_publisher_channel_xi2)
    print('~' *33)
    # <read-write PipeConnection, handle 244>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
        
    queue_xi2.put(['DragonXi2_00', target_xi2, 'sensing!']) 
    
    
    print('~' *33)
    print("SENSE: PUT DATA TO QUEUE: ", queue_xi2)
    print('~' *33)
    # <queue4xi.Queue4Xi object at 0x02CBBBD0>    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    print('~' *33)
    print("SENSE: SENDING DATA TO THE PIPE PUBLISHER END", pipe_publisher_channel_xi2)
    print('~' *33)
    # <read-write PipeConnection, handle 244>
         
    # ---------------------------------------------------------------------------------------------
    # send data to the pipe's publisher end - 15 messages
    # ---------------------------------------------------------------------------------------------
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_01', 'BIO ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_02', 'CO2 ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_03', 'Coal ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_04', 'Diesel ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_05', 'Electricity ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_06', 'Fusion ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_07', 'Gas ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_08', 'Geo ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_09', 'Hydrogen ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_10', 'Lithium ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_11', 'Nuclear Power ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_12', 'Ocean ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_13', 'Oil ',target_xi2]) 
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_14', 'Solar ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_15', 'Wind ',target_xi2]) 
    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    print('=' *33)
    print("SENSE: SENT ALL DATA TO THE PIPE PUBLISHER END", pipe_publisher_channel_xi2)
    print('=' *33)
    # <read-write PipeConnection, handle 244>
    # { Queue4Xi : _feed ; (Step 8/9q) warned; possible-IndexError-warned-by-feed-of-Queue4Xi:  ** <class 'IndexError'> ** ; time: 15:39:38 03/29/10 FLE Daylight Time}
    # SENSE: SENT ALL DATA TO THE PIPE PUBLISHER END <read-write PipeConnection, handle 244>
    
    print('=' *33)
    print("SENSE: SENSED TARGET: ", target_xi2)
    print('=' *33)
#</function4xi>

               
# -------------------------------------------------------------------------------------------------
#<function4xi function = "reason" usage = "
#   reason process
#">
# -------------------------------------------------------------------------------------------------
def reason(target_param, queue_param, pipe_param):
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
   
    target_xi4 = target_param
    
    print('=' *33)    
    print("REASON: REASONING TARGET: ", target_xi4)
    print('=' *33)  
    # Energy 
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
       
    queue_xi4 = queue_param    
    print('~' *33)    
    print("REASON: REASONING QUEUE: ", queue_xi4)
    print('~' *33)  
    # <queue4xi.Queue4Xi object at 0x02CBBE50>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
       
    pipe_publisher_channel_xi4 = pipe_param    
    print('~' *33)    
    print("REASON: REASONING PIPE PUBLISHER CHANNEL: ", pipe_publisher_channel_xi4)
    print('~' *33)  
    # <read-write PipeConnection, handle 292>        
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    queue_xi4 = queue_param  
    print('~' *33)    
    print("REASON: PUTTING DATA TO QUEUE: ", queue_xi4)
    print('~' *33)  
    # <queue4xi.Queue4Xi object at 0x02CBBE50>
       
    queue_xi4.put(['DragonXi4_00', target_xi4, 'portfolio must be sustainable!']) 
    

       
    print('~' *33)    
    print("REASON: PUT DATA TO QUEUE: ", queue_xi4)
    print('~' *33)
    # { Queue4Xi : put ; (Step 5/8a) passing; object-passing-to-buffer-append-of-queue2xi-by-put-of-Queue4Xi: ['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']; time: 15:39:39 03/29/10 FLE Daylight Time}
    # <queue4xi.Queue4Xi object at 0x02CBBE50>
    # <read-write PipeConnection, handle 292>
    
    # ---------------------------------------------------------------------------------------------
    # send data to the pipe's publisher end - 7 messages
    # ---------------------------------------------------------------------------------------------    print('~' *33)    
    print("REASON: SENDING DATA TO PIPE PUBLISHER CHANNEL END: ", pipe_publisher_channel_xi4)
    print('~' *33)            
    # <read-write PipeConnection, handle 292>
    
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_01', 'BIO ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_02', 'Geo ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_03', 'Hydrogen ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_04', 'Nuclear Power ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_05', 'Ocean ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_06', 'Solar ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_07', 'Wind ',target_xi4])    
    
    print('=' *33)    
    print("REASON: SENT DATA TO PIPE PUBLISHER CHANNEL END: ", pipe_publisher_channel_xi4)
    print('=' *33)            
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
      
    print('=' *33)    
    print("REASON: REASONED TARGET: ", target_xi4)
    print('=' *33)  
    # REASON: REASONED TARGET:  { Queue4Xi : _feed ; (Step 8/9h) set; object-set-by-feed-of-Queue4Xi to: ['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']; time: 15:39:39 03/29/10 FLE Daylight Time}
    # Energy 
#</function4xi>
            
# -------------------------------------------------------------------------------------------------
#<function4xi function = "ace" usage = "
#   acing process
#">
# -------------------------------------------------------------------------------------------------
def ace(target_param, queue_param, pipe_param):
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
  
    target_xi8 = target_param
  
    print('=' *33)    
    print("ACE: ACING TARGET: ", target_xi8)
    print('=' *33)      
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
      
    queue_xi8 = queue_param
    print('~' *33)    
    print("ACE: PUTTING DATA TO QUEUE: ", queue_xi8)
    print('~' *33)    
    
    queue_xi8.put(['DragonXi8_00', target_xi8, 'to be aced!']) # puts to its queue       
    
    print('~' *33)    
    print("ACE: PUT DATA TO QUEUE: ", queue_xi8)
    print('~' *33)        
    
    # ---------------------------------------------------------------------------------------------
    # send data to the pipe's publisher end - 5 messages
    # ---------------------------------------------------------------------------------------------
    
    pipe_publisher_channel_xi8 = pipe_param        
    print('~' *33)    
    print("ACE: SENDING DATA TO PIPE PUBLISHER CHANNEL END: ", pipe_publisher_channel_xi8)
    print('~' *33)            

    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_01', 'BIO ',target_xi8])
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_02', 'Hydrogen ',target_xi8])
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_03', 'Nuclear Power ',target_xi8])
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_04', 'Solar ',target_xi8])
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_05', 'Wind ',target_xi8])    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
      
    print('~' *33)    
    print("ACE: SENT DATA TO PIPE PUBLISHER CHANNEL END: ", pipe_publisher_channel_xi8)
    print('~' *33)            
    
    print('=' *33)    
    print("ACE: ACED TARGET: ", target_xi8)
    print('=' *33)      
#</function4xi>

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "phase1" usage = "
#   testing with standard multiprocessing 
#">
# -------------------------------------------------------------------------------------------------    
def phase1():

    # =============================================================================================
    # PHASE I: use the original multiprocessing modules
    # =============================================================================================
    
    print('=' *33)
    print("STARTING PHASE 1 WITH ORIGINAL MULTIPROCESSING MODULES ", time4xi())
    print('=' *33)
        
    # ---------------------------------------------------------------------------------------------
    # create three multiprocessing queues, one for each process to be created 
    # ---------------------------------------------------------------------------------------------
    
    queue2xi = Queue()
    queue4xi = Queue()
    queue8xi = Queue()
    
    # ---------------------------------------------------------------------------------------------
    # create multiprocessing pipes with consumer and publisher ends
    # ---------------------------------------------------------------------------------------------
    pipe2xi_consumer_channel, pipe2xi_publisher_channel = Pipe() # duplex default
    pipe4xi_consumer_channel, pipe4xi_publisher_channel = Pipe() # duplex default
    pipe8xi_consumer_channel, pipe8xi_publisher_channel = Pipe() # duplex default

    
    
    # ---------------------------------------------------------------------------------------------
    # SENSE IT!
    # ---------------------------------------------------------------------------------------------
    print('~2' *33)
    
    
    # ---------------------------------------------------------------------------------------------
    # create process giving the function and its arguments string, queue and pipe's publisher end
    # ---------------------------------------------------------------------------------------------    
    
    process2xi = Process(target=sense, args=('Energy ',queue2xi, pipe2xi_publisher_channel))
    process2xi.start()
    
    # ---------------------------------------------------------------------------------------------
    # 15 messages - get from queue and receive messages from pipe's consumer end
    # ---------------------------------------------------------------------------------------------    
    
    print (queue2xi.get())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    
    process2xi.join()
    
    # ---------------------------------------------------------------------------------------------
    # REASON IT!
    #
    # ---------------------------------------------------------------------------------------------
    
    # create process giving the function and its arguments string, queue and pipe's publisher end 
    
    print('~4' *33)
    
    process4xi = Process(target=reason, args=('Energy ',queue4xi, pipe4xi_publisher_channel))
    process4xi.start()
    
    # ---------------------------------------------------------------------------------------------
    # 7 messages - get from queue and receive messages from pipe's consumer end
    # ---------------------------------------------------------------------------------------------
        
    print (queue4xi.get())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    process4xi.join()
    
    # ---------------------------------------------------------------------------------------------
    # ACE IT!
    # 
    # ---------------------------------------------------------------------------------------------
    # create process giving the function and its arguments string, queue and pipe's publisher end
    print('~8' *33)
    
    
    process8xi = Process(target=ace, args=('Energy ',queue8xi, pipe8xi_publisher_channel))
    process8xi.start()
    print (queue8xi.get())
    
    # ---------------------------------------------------------------------------------------------
    # 5 messages - get from queue and receive messages from pipe's consumer end
    # ---------------------------------------------------------------------------------------------
        
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    
    process8xi.join()
    # ---------------------------------------------------------------------------------------------
    # Notes:
    #       above assumed the main to know amount of messages
    #       no locks were used
    
    print('=' *33)
    print("COMPLETED PHASE 1 WITH ORIGINAL MULTIPROCESSING MODULES ", time4xi())
    print('=' *33)

#    =================================
#    STARTING PHASE 1 WITH ORIGINAL MULTIPROCESSING MODULES
#    =================================
#    ~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2
#    ['DragonXi2_00', 'Energy ', 'sensing!']
#    ['DragonXi2_Sensing_01', 'BIO ', 'Energy ']
#    ['DragonXi2_Sensing_02', 'CO2 ', 'Energy ']
#    ['DragonXi2_Sensing_03', 'Coal ', 'Energy ']
#    ['DragonXi2_Sensing_04', 'Diesel ', 'Energy ']
#    ['DragonXi2_Sensing_05', 'Electricity ', 'Energy ']
#    ['DragonXi2_Sensing_06', 'Fusion ', 'Energy ']
#    ['DragonXi2_Sensing_07', 'Gas ', 'Energy ']
#    ['DragonXi2_Sensing_08', 'Geo ', 'Energy ']
#    ['DragonXi2_Sensing_09', 'Hydrogen ', 'Energy ']
#    ['DragonXi2_Sensing_10', 'Lithium ', 'Energy ']
#    ['DragonXi2_Sensing_11', 'Nuclear Power ', 'Energy ']
#    ['DragonXi2_Sensing_12', 'Ocean ', 'Energy ']
#    ['DragonXi2_Sensing_13', 'Oil ', 'Energy ']
#    ['DragonXi2_Sensing_14', 'Solar ', 'Energy ']
#    ['DragonXi2_Sensing_15', 'Wind ', 'Energy ']
#    ~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4
#    ['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']
#    ['DragonXi4_Reasoning_01', 'BIO ', 'Energy ']
#    ['DragonXi4_Reasoning_02', 'Geo ', 'Energy ']
#    ['DragonXi4_Reasoning_03', 'Hydrogen ', 'Energy ']
#    ['DragonXi4_Reasoning_04', 'Nuclear Power ', 'Energy ']
#    ['DragonXi4_Reasoning_05', 'Ocean ', 'Energy ']
#    ['DragonXi4_Reasoning_06', 'Solar ', 'Energy ']
#    ['DragonXi4_Reasoning_07', 'Wind ', 'Energy ']
#    ~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8
#    ['DragonXi8_00', 'Energy ', 'to be aced!']
#    ['DragonXi8_Ace_01', 'BIO ', 'Energy ']
#    ['DragonXi8_Ace_02', 'Hydrogen ', 'Energy ']
#    ['DragonXi8_Ace_03', 'Nuclear Power ', 'Energy ']
#    ['DragonXi8_Ace_04', 'Solar ', 'Energy ']
#    ['DragonXi8_Ace_05', 'Wind ', 'Energy ']
#    =================================
#    COMPLETED PHASE 1 WITH ORIGINAL MULTIPROCESSING MODULES
#    =================================  
  
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "phase2" usage = "
#   testing with Dragon2Xi multiprocessing
#">
# -------------------------------------------------------------------------------------------------    
def phase2(): 
    
    # =============================================================================================
    # PHASE II: use Dragon2Xi modules
    # =============================================================================================
    
      
    print('=' *33)
    print("STARTING PHASE II WITH DRAGON2XI MULTIPROCESSING MODULES ", time4xi())
    print('=' *33)
    
    
    # ---------------------------------------------------------------------------------------------
    # create three multiprocessing queues, one for each process to vbe created 
    # ---------------------------------------------------------------------------------------------
    
    queue2xi = Queue2Xi()
    queue4xi = Queue2Xi()
    queue8xi = Queue2Xi()
    
    # ---------------------------------------------------------------------------------------------
    # create multiprocessing pipes with consumer and publisher ends
    # ---------------------------------------------------------------------------------------------
    
    pipe2xi_consumer_channel, pipe2xi_publisher_channel = Pipe2Xi() # duplex default
    pipe4xi_consumer_channel, pipe4xi_publisher_channel = Pipe2Xi() # duplex default
    pipe8xi_consumer_channel, pipe8xi_publisher_channel = Pipe2Xi() # duplex default

    
    
    # ---------------------------------------------------------------------------------------------
    # SENSE IT!
    # ---------------------------------------------------------------------------------------------
    print("\n with yourDragonXi! ", time4xi())
    
    # ---------------------------------------------------------------------------------------------
    # create process giving the function and its arguments string, queue and pipe's publisher end
    # ---------------------------------------------------------------------------------------------
        
    process2xi = Process2Xi(target=sense, args=('Energy ',queue2xi, pipe2xi_publisher_channel))
    process2xi.start()
    
    # ---------------------------------------------------------------------------------------------
    # 15 messages - get from queue and receive messages from pipe's consumer end
    # ---------------------------------------------------------------------------------------------
    
    print (queue2xi.get())
    
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    
    process2xi.join()
    
    # ---------------------------------------------------------------------------------------------
    # REASON IT!
    #
    # ---------------------------------------------------------------------------------------------
    
    # ---------------------------------------------------------------------------------------------    
    # create process giving the function and its arguments string, queue and pipe's publisher end 
    # ---------------------------------------------------------------------------------------------
    
    print("\n with yourDragonXi! ", time4xi())
    process4xi = Process2Xi(target=reason, args=('Energy ',queue4xi, pipe4xi_publisher_channel))
    process4xi.start()
    
    # ---------------------------------------------------------------------------------------------
    # 7 messages - get from queue and receive messages from pipe's consumer end
    # ---------------------------------------------------------------------------------------------    
    print (queue4xi.get())
    
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    
    process4xi.join()
    
    # ---------------------------------------------------------------------------------------------
    # ACE IT!
    # ---------------------------------------------------------------------------------------------
    
    # ---------------------------------------------------------------------------------------------    
    # create process giving the function and its arguments string, queue and pipe's publisher end
    # ---------------------------------------------------------------------------------------------
    
    print("\n with yourDragonXi! ", time4xi())
    process8xi = Process2Xi(target=ace, args=('Energy ',queue8xi, pipe8xi_publisher_channel))
    process8xi.start()
    print (queue8xi.get())
    
    # ---------------------------------------------------------------------------------------------
    # 5 messages - get from queue and receive messages from pipe's consumer end
    # ---------------------------------------------------------------------------------------------    
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    
    process8xi.join()

      
    print('=' *33)
    print("COMPLETED PHASE II WITH DRAGON2XI MULTIPROCESSING MODULES ", time4xi())
    print('=' *33)

#    =================================
#    STARTING PHASE II WITH DRAGON2XI MULTIPROCESSING MODULES
#    =================================
#    
#     with yourDragonXi!
#    ['DragonXi2_00', 'Energy ', 'sensing!']
#    ['DragonXi2_Sensing_01', 'BIO ', 'Energy ']
#    ['DragonXi2_Sensing_02', 'CO2 ', 'Energy ']
#    ['DragonXi2_Sensing_03', 'Coal ', 'Energy ']
#    ['DragonXi2_Sensing_04', 'Diesel ', 'Energy ']
#    ['DragonXi2_Sensing_05', 'Electricity ', 'Energy ']
#    ['DragonXi2_Sensing_06', 'Fusion ', 'Energy ']
#    ['DragonXi2_Sensing_07', 'Gas ', 'Energy ']
#    ['DragonXi2_Sensing_08', 'Geo ', 'Energy ']
#    ['DragonXi2_Sensing_09', 'Hydrogen ', 'Energy ']
#    ['DragonXi2_Sensing_10', 'Lithium ', 'Energy ']
#    ['DragonXi2_Sensing_11', 'Nuclear Power ', 'Energy ']
#    ['DragonXi2_Sensing_12', 'Ocean ', 'Energy ']
#    ['DragonXi2_Sensing_13', 'Oil ', 'Energy ']
#    ['DragonXi2_Sensing_14', 'Solar ', 'Energy ']
#    ['DragonXi2_Sensing_15', 'Wind ', 'Energy ']
#    
#     with yourDragonXi!
#    ['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']
#    ['DragonXi4_Reasoning_01', 'BIO ', 'Energy ']
#    ['DragonXi4_Reasoning_02', 'Geo ', 'Energy ']
#    ['DragonXi4_Reasoning_03', 'Hydrogen ', 'Energy ']
#    ['DragonXi4_Reasoning_04', 'Nuclear Power ', 'Energy ']
#    ['DragonXi4_Reasoning_05', 'Ocean ', 'Energy ']
#    ['DragonXi4_Reasoning_06', 'Solar ', 'Energy ']
#    ['DragonXi4_Reasoning_07', 'Wind ', 'Energy ']
#    
#     with yourDragonXi!
#    ['DragonXi8_00', 'Energy ', 'to be aced!']
#    ['DragonXi8_Ace_01', 'BIO ', 'Energy ']
#    ['DragonXi8_Ace_02', 'Hydrogen ', 'Energy ']
#    ['DragonXi8_Ace_03', 'Nuclear Power ', 'Energy ']
#    ['DragonXi8_Ace_04', 'Solar ', 'Energy ']
#    ['DragonXi8_Ace_05', 'Wind ', 'Energy ']
#    =================================
#    COMPLETED PHASE II WITH DRAGON2XI MULTIPROCESSING MODULES
#    =================================           
#</function4xi>

# -----------------------------------------------------------------------------------------------------    
#<function4xi function = "sense4xi" usage = "
#   sensing
#">
# -----------------------------------------------------------------------------------------------------    
def sense4xi(step): 

    # -------------------------------------------------------------------------------------------------
    # common ones
    # -------------------------------------------------------------------------------------------------
    
    global ack4queues
    global nack4queues
    
    global ack4pipes
    global nack4pipes
    
    global ack4process
    global nack4process
    
    global ack4process
    global nack4process
    
    global ack4start
    global nack4start   
            
    global ack4run
    global nack4run

    # -------------------------------------------------------------------------------------------------
    # sense ones
    # -------------------------------------------------------------------------------------------------
    
    global queue2xi
    global pipe2xi_consumer_channel
    global pipe2xi_publisher_channel
    global process2xi    
    
    print("\n SENSE4XI: RECEIVED STEP = ", step)
    print("\n SENSE4XI: GLOBAL ack4queues = ", ack4queues)
    print("\n SENSE4XI: GLOBAL nack4queues = ", nack4queues)
    print("\n SENSE4XI: GLOBAL ack4pipes = ", ack4pipes)
    print("\n SENSE4XI: GLOBAL nack4pipes = ", nack4pipes)    
    print("\n SENSE4XI: GLOBAL ack4process = ", ack4process)
    print("\n SENSE4XI: GLOBAL nack4process = ", nack4process)
    print("\n SENSE4XI: GLOBAL ack4start = ", ack4start)
    print("\n SENSE4XI: GLOBAL nack4start = ", nack4start)
    print("\n SENSE4XI: GLOBAL ack4run = ", ack4run)
    print("\n SENSE4XI: GLOBAL nack4run = ", nack4run)  
    
    print("\n SENSE4XI: GLOBAL queue2xi = ", queue2xi) 
    print("\n SENSE4XI: GLOBAL pipe2xi_consumer_channel = ", pipe2xi_consumer_channel)     
    print("\n SENSE4XI: GLOBAL pipe2xi_publisher_channel = ", pipe2xi_publisher_channel)     
    print("\n SENSE4XI: GLOBAL process2xi  = ", process2xi )     
                                   
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
          
    if step == "STEP2A":
        # ---------------------------------------------------------------------------------------------
        # (STEP 2A)
        # ---------------------------------------------------------------------------------------------
       
        print("\n (STEP 2A OF SENSE4XI): CREATING QUEUES2XI FOR SENSING ", time4xi())
        
        ack4queues = False
        nack4queues = True 
        try:
        
            # -----------------------------------------------------------------------------------------    
            #  (Step 2A):
            # -----------------------------------------------------------------------------------------     
            
            print('=' *33)    
            print("\n (STEP 2A1 OF SENSE4XI): CREATING QUEUE2XI ", time4xi())
            print('=' *33)           
                 
            queue2xi = Queue4Xi()
            
            print('=' *33)    
            print("\n (STEP 2A2 OF SENSE4XI): CREATED QUEUE2XI ", time4xi())
            print('=' *33)           
            
            print(queue2xi)
            #<queue4xi.Queue4Xi object at 0x02D84C10>
             
            ack4queues = True 
            nack4queues = False
        except:
        
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
            print("\n (STEP 2A3 OF SENSE4XI): *** FAILED TO CREATE QUEUE2XI *** ", time4xi())
                
        return
    else:
        print("\n SENSE4XI: CONSIDERED DONE STEP2A ", time4xi())
        
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
 
    if step == "STEP2B":                        
        # ---------------------------------------------------------------------------------------------
        #(STEP 2B)
        # ---------------------------------------------------------------------------------------------
     
        print("\n (STEP 2B1 OF SENSE4XI): CREATING PIPE2XI WITH CONSUMER AND PUBLISHER ENDS ", time4xi())
        ack4pipes = False
        nack4pipes = True
        try:
        
            # -----------------------------------------------------------------------------------------    
            # OK
            # -----------------------------------------------------------------------------------------     
                  
            pipe2xi_consumer_channel, pipe2xi_publisher_channel = Pipe4Xi()
            
            print("\n (STEP 2B2 OF SENSE4XI) CREATED PIPE2XI_CONSUMER_CHANNEL ", time4xi())   
            print(pipe2xi_consumer_channel)
            #<read-write PipeConnection, handle 320>
            
            print("\n (STEP 2B3 OF SENSE4XI) CREATED PIPE2XI_PUBLISHER_CHANNEL ", time4xi())  
            print(pipe2xi_publisher_channel)
            #<read-write PipeConnection, handle 252>
            
           
            print("\n (STEP 2B4 OF SENSE4XI): CREATED PIPE2XI WITH CONSUMER AND PUBLISHER ENDS ", time4xi())
            
            ack4pipes = True
            nack4pipes = False
        except:
        
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
            print("\n (STEP 2B3 OF SENSE4XI): *** FAILED TO CREATE PIPE2XI WITH CONSUMER AND PUBLISHER ENDS *** ", time4xi())
    
        return
    else:
        print("\n SENSE4XI: CONSIDERED DONE STEP2B ", time4xi())
        
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
         
    if step == "STEP2C":    
        # ---------------------------------------------------------------------------------------------
        # (STEP 2C): 
        # ---------------------------------------------------------------------------------------------
       
        ack4process = False
        nack4process = True
        
        if ((ack4queues is True) and (ack4pipes is True)):
        
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
             
            print("\n (STEP 2C1 OF SENSE4XI): CREATING PROCESS GIVING THE FUNCTION AND ITS ARGUMENTS STRING, QUEUE AND PIPE'S PUBLISHER END ", time4xi())
            
            print("\n (STEP 2C2 OF SENSE4XI): PASSING QUEUE2XI to PROCESS4XI: ", queue2xi)
            print("\n (STEP 2C3 OF SENSE4XI): PASSING PIPE2XI_PUBLISHER_CHANNEL to PROCESS4XI: ", pipe2xi_publisher_channel)            
            
            try:
       
                # -------------------------------------------------------------------------------------    
                # 
                # -------------------------------------------------------------------------------------     
                
                process2xi = Process4Xi(target=sense, args=('Energy ',queue2xi, pipe2xi_publisher_channel))
                
                print("\n (STEP 2C4 OF SENSE4XI) CREATED PROCESS: ", str(process2xi))
                #<Process4Xi(Process4Xi-1, initial)>
                
                ack4process = True
                nack4process = False
            except:
       
                # -------------------------------------------------------------------------------------    
                #
                # -------------------------------------------------------------------------------------     
                
                print("\n (STEP 2C5 OF SENSE4XI): *** FAILED TO CREATE PROCESS GIVING THE FUNCTION AND ITS ARGUMENTS STRING, QUEUE AND PIPE'S PUBLISHER END ", time4xi())
                   
        else:
        
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
             
            print("\n (STEP 2C6 OF SENSE4XI): ** HAD TO SKIP CREATING PROCESS GIVING THE FUNCTION AND ITS ARGUMENTS STRING, QUEUE AND PIPE'S PUBLISHER END ** ", time4xi())
                
        return
    else:
        print("\n SENSE4XI: CONSIDERED DONE STEP2C ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
 
    if step == "STEP2D":                          
        # ---------------------------------------------------------------------------------------------
        # STEP 2D:
        # ---------------------------------------------------------------------------------------------    
        ack4start = False
        nack4start = True    
        
        ack4run = False
        nack4run = True
            
        if ack4process is True:
    
               
            print("\n (STEP 2D1 OF SENSE4XI): STARTING PROCESS PROCESS2XI GIVING THE FUNCTION AND ITS ARGUMENTS STRING, QUEUE AND PIPE PUBLISHER END ", time4xi())
    
            process2xi.start() 
            print("\n (STEP 2D2 OF SENSE4XI) STARTED PROCESS: ", str(process2xi))
            # <Process4Xi(Process4Xi-1, stopped)>
            ack4start = True
            nack4start = False
            
            print("\n (STEP 2D3 OF SENSE4XI) CALLING RUN PROCESS: ", str(process2xi))        
            # <Process4Xi(Process4Xi-1, stopped)>
            
            process2xi.run()
            
            print("\n (STEP 2D4 OF SENSE4XI) PERFORMED RUN PROCESS: ", str(process2xi))
            #<Process4Xi(Process4Xi-1, stopped)>
            # SENSING TARGET:  Energy 
            # SENSING QUEUE:  <queue4xi.Queue4Xi object at 0x02C46C70>
            # SENSING PIPE PUBLISHER CHANNEL:  <read-write PipeConnection, handle 244>
            # SENSING TARGET:  Energy 
            # SENSING QUEUE:  <queue4xi.Queue4Xi object at 0x02C46C70>
            # SENSING PIPE PUBLISHER CHANNEL:  <read-write PipeConnection, handle 244>
            # PUT DATA TO QUEUE:  <queue4xi.Queue4Xi object at 0x02C46C70>
            # SENDING DATA TO THE PIPE PUBLISHER END <read-write PipeConnection, handle 244>
            # SENT ALL DATA TO THE PIPE PUBLISHER END <read-write PipeConnection, handle 244>
            # SENSED TARGET: 
            # { Queue4Xi : _feed ; (Step 8/9q) warned; possible-IndexError-warned-by-feed-of-Queue4Xi:  ** <class 'IndexError'> ** ; time: 14:01:10 03/29/10 FLE Daylight Time}
            
            
            
            ack4run = True 
            nack4run = False       
             
        else:
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
               
            print("\n (STEP 2D5 OF SENSE4XI): ** HAD TO SKIP STARTING PROCESS ** ", time4xi())

        return
    else:
        print("\n SENSE4XI: CONSIDERED DONE STEP2D ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
                     
    if step == "STEP2E":        
        # ---------------------------------------------------------------------------------------------
        # STEP 2E:
        # ---------------------------------------------------------------------------------------------   
        ack4queue = False
        nack4queue = True
        
        count2try = 0
        
        while ((count2try < 9) and (ack4queue is False)):
        
            # -------------------------------------------------------------------------------------    
            # 
            # -------------------------------------------------------------------------------------     
            try:         
                print("\n (STEP 2E1 OF SENSE4XI): GETTING FROM QUEUE  ", time4xi())
                #  (STEP 2D1): GETTING FROM QUEUE 
                print (queue2xi.get())
                        
                print("\n (STEP 2E2 OF SENSE4XI): GOT FROM QUEUE  ", time4xi())
                # { Queue4Xi : get ; (Step 14/14b) returning; response-returning-by-get-of-Queue4Xi: ['DragonXi2_00', 'Energy ', 'sensing!']; time: 17:37:53 03/29/10 FLE Daylight Time}
                # ['DragonXi2_00', 'Energy ', 'sensing!']
        
                ack4queue = True
                nack4queue = False 
                   
            except:
           
                # -------------------------------------------------------------------------------------    
                #
                # -------------------------------------------------------------------------------------     
     
                print("\n (STEP 2E3 OF SENSE4XI): ** RE-TRIAL FROM QUEUE NEEDED **  ", time4xi())
                count2try = count2try + 1
                     
    
        return
    else:
        print("\n SENSE4XI: CONSIDERED DONE STEP2E ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
         
    if step == "STEP2F":
                                
        # ---------------------------------------------------------------------------------------------
        # STEP 2F: 
        # ---------------------------------------------------------------------------------------------      
        print("\n (STEP 2F0 OF SENSE4XI): CONTINUING ", time4xi()) 
        
    
        try: 
       
            # -------------------------------------------------------------------------------------    
            # 15 messages 
            # -------------------------------------------------------------------------------------     
                  
            print ("\n (STEP 2F1 OF SENSE4XI): START RECEIVING FROM PIPE2XI ", time4xi())
            
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print ("\n (STEP 2F2 OF SENSE4XI): RECEIVED FROM PIPE2XI ", time4xi())
            # ['DragonXi2_Sensing_01', 'BIO ', 'Energy ']
            # ['DragonXi2_Sensing_02', 'CO2 ', 'Energy ']
            # ['DragonXi2_Sensing_03', 'Coal ', 'Energy ']
            # ['DragonXi2_Sensing_04', 'Diesel ', 'Energy ']
            # ['DragonXi2_Sensing_05', 'Electricity ', 'Energy ']
            # ['DragonXi2_Sensing_06', 'Fusion ', 'Energy ']
            # ['DragonXi2_Sensing_07', 'Gas ', 'Energy ']
            # ['DragonXi2_Sensing_08', 'Geo ', 'Energy ']
            # ['DragonXi2_Sensing_09', 'Hydrogen ', 'Energy ']
            # ['DragonXi2_Sensing_10', 'Lithium ', 'Energy ']
            # ['DragonXi2_Sensing_11', 'Nuclear Power ', 'Energy ']
            # ['DragonXi2_Sensing_12', 'Ocean ', 'Energy ']
            # ['DragonXi2_Sensing_13', 'Oil ', 'Energy ']
            # ['DragonXi2_Sensing_14', 'Solar ', 'Energy ']
            # ['DragonXi2_Sensing_15', 'Wind ', 'Energy ']
            # 
            #  (STEP 2E2): RECEIVED FROM PIPE2XI            
            
        except:
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
                
            print ("\n (STEP 2F3 OF SENSE4XI): *** FAILED TO RECEIVE FROM PIPE2XI ", time4xi())
    
        return
    else:
        print("\n SENSE4XI: CONSIDERED DONE STEP2F ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
      
    if step == "STEP2G":
                   
        # ---------------------------------------------------------------------------------------------
        # Steps 2G: 
        # ---------------------------------------------------------------------------------------------           
    
        print ("\n (STEP 2G1 OF SENSE4XI) STARTING JOINING PROCESS ", time4xi())
            
        try:    
                                
            process2xi.join()
           
            print ("\n (STEP 2G2 OF SENSE4XI) PERFORMED PROCESS JOIN ", time4xi())
            # OK
            
        except:
            print ("\n (STEP 2G3 OF SENSE4XI) *** FAILED TO PERFORM PROCESS JOIN ", time4xi())    
            
        return
    else:
        print("\n SENSE4XI: CONSIDERED DONE STEP2G ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
         
    if step == "STEP2H":    
        # ---------------------------------------------------------------------------------------------
        # Steps 2H: 
        # ---------------------------------------------------------------------------------------------           
    
        print ("\n (STEP 2H1 OF SENSE4XI) STARTING TERMINATING PROCESS ", time4xi())
            
        try:    
                                
            process2xi.terminate()
           
            print ("\n (STEP 2H2 OF SENSE4XI) TERMINATED PROCESS ", time4xi())
            # OK
            
        except:
            print ("\n (STEP 2H3 OF SENSE4XI) *** FAILED TO TERMINATE PROCESS *** ", time4xi())
        
        return
    else:
        print("\n SENSE4XI: CONSIDERED DONE STEP2H ", time4xi())
            
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
     
    if step == "STEP2I":
                  
        # ---------------------------------------------------------------------------------------------
        # Steps 2I: 
        # ---------------------------------------------------------------------------------------------           
    
        print ("\n (STEP 2I1 OF SENSE4XI) SKIPPED DELETING PROCESS OBJECT - TESTED ONCE - DELETES FROM NAMESPACE  ", time4xi())
                     
        # del process2xi    
        
        print ("\n (STEP 2I2 OF SENSE4XI) SKIPPED DELETED PROCESS OBJECT- TESTED ONCE- DELETES FROM NAMESPACE   ", time4xi())        

        
        return
    else:
        print("\n SENSE4XI: CONSIDERED DONE STEP2I ", time4xi()) 
           
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
    print("\n SENSE4XI: TESTING STEP: ", step)       
    # STEP2J
    
    # =============================================================================================
    # (STEP 2J): SENSED IT! 
    # =============================================================================================        
    print ("\n (STEP 2J1 OF SENSE4XI) STARTED ", time4xi())   
    #hit:
    # { ForkingPickler4Xi : save_dict ; passing; EMPTY-DICT-passing-to-write-by-save-dict-of-ForkingPickler4Xi: b'}'; time: 17:37:53 03/29/10 FLE Daylight Time}
    # { ForkingPickler4Xi : save_dict ; performed; write-performed-by-save-dict-of-ForkingPickler4Xi: <built-in method write of _io.BufferedWriter object at 0x02D7C330>; time: 17:37:53 03/29/10 FLE Daylight Time}
    # { ForkingPickler4Xi : save ; (Step 3/9f) hit; function-hit-by-save-of-ForkingPickler4Xi:  *** <function save_dict at 0x02BBCD68> *** ; time: 17:37:53 03/29/10 FLE Daylight Time}

    # ---------------------------------------------------------------------------------------------     
    # initialize global variables back to their module values
    # --------------------------------------------------------------------------------------------- 
    
    # ---------------------------------------------------------------------------------------------     
    # common ones
    # ---------------------------------------------------------------------------------------------  
                   
    ack4queues = False
    nack4queues = True
    
    ack4pipes = False
    nack4pipes = True
    
    ack4process = False
    nack4process = True
    
    ack4process = False
    nack4process = True
    
    ack4start = False
    nack4start = True   
         
    ack4run = False
    nack4run = True
        
    print ("\n (STEP 2J2 OF SENSE4XI) INITIALIZED ", time4xi())    
        
    return

#</function4xi> 
    
# -----------------------------------------------------------------------------------------------------
#<function4xi function = "reason4xi" usage = "
#   REASON with Dragon4Xi multiprocessing
#">
# -----------------------------------------------------------------------------------------------------    
def reason4xi(step): 

    # -------------------------------------------------------------------------------------------------
    # common ones
    # -------------------------------------------------------------------------------------------------
    
    global ack4queues
    global nack4queues
    
    global ack4pipes
    global nack4pipes
    
    global ack4process
    global nack4process
    
    global ack4process
    global nack4process
    
    global ack4start
    global nack4start   
            
    global ack4run
    global nack4run

    # -------------------------------------------------------------------------------------------------
    # reason ones
    # -------------------------------------------------------------------------------------------------
    
    global queue4xi
    global pipe4xi_consumer_channel
    global pipe4xi_publisher_channel
    global process4xi    
    
    print("\n REASON4XI: RECEIVED STEP = ", step)
    print("\n REASON4XI: GLOBAL ack4queues = ", ack4queues)
    print("\n REASON4XI: GLOBAL nack4queues = ", nack4queues)
    print("\n REASON4XI: GLOBAL ack4pipes = ", ack4pipes)
    print("\n REASON4XI: GLOBAL nack4pipes = ", nack4pipes)    
    print("\n REASON4XI: GLOBAL ack4process = ", ack4process)
    print("\n REASON4XI: GLOBAL nack4process = ", nack4process)
    print("\n REASON4XI: GLOBAL ack4start = ", ack4start)
    print("\n REASON4XI: GLOBAL nack4start = ", nack4start)
    print("\n REASON4XI: GLOBAL ack4run = ", ack4run)
    print("\n REASON4XI: GLOBAL nack4run = ", nack4run)  
    
    print("\n REASON4XI: GLOBAL queue4xi = ", queue4xi) 
    print("\n REASON4XI: GLOBAL pipe4xi_consumer_channel = ", pipe4xi_consumer_channel)     
    print("\n REASON4XI: GLOBAL pipe4xi_publisher_channel = ", pipe4xi_publisher_channel)     
    print("\n REASON4XI: GLOBAL process4xi  = ", process4xi )     
    
    # REASON4XI: RECEIVED STEP =  STEP4F
    # REASON4XI: GLOBAL ack4queues =  True
    # REASON4XI: GLOBAL nack4queues =  False
    # REASON4XI: GLOBAL ack4pipes =  True
    # REASON4XI: GLOBAL nack4pipes =  False
    # REASON4XI: GLOBAL ack4process =  True
    # REASON4XI: GLOBAL nack4process =  False
    # REASON4XI: GLOBAL ack4start =  True
    # REASON4XI: GLOBAL nack4start =  False
    # REASON4XI: GLOBAL ack4run =  True
    # REASON4XI: GLOBAL nack4run =  False
    # REASON4XI: GLOBAL queue4xi =  <queue4xi.Queue4Xi object at 0x02EA16B0>
    # REASON4XI: GLOBAL pipe4xi_consumer_channel =  <read-write PipeConnection, handle 240>
    # REASON4XI: GLOBAL pipe4xi_publisher_channel =  <read-write PipeConnection, handle 244>
    # REASON4XI: GLOBAL process4xi  =  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ <--- ????
    # { Process4Xi : __repr__ ; started; repr-of-Process4Xi-started: ; time: 10:43:22 03/30/10 FLE Daylight Time}
    # concluded: it looks like printing a process object also activates its __repr__ method, which is NOT good !
                                   
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
          
    if step == "STEP4A":
        # ---------------------------------------------------------------------------------------------
        # (STEP 4A)
        # ---------------------------------------------------------------------------------------------
        
        print("\n (STEP 4A OF REASON4XI): CREATING QUEUES4XI FOR REASONING ", time4xi())
        
        ack4queues = False
        nack4queues = True 
        try:
        
            # -----------------------------------------------------------------------------------------    
            #  (Step 4A):
            # -----------------------------------------------------------------------------------------     
            
            print('=' *33)    
            print("\n (STEP 4A1 OF REASON4XI): CREATING QUEUE4XI ", time4xi())
            print('=' *33)           
                 
            queue4xi = Queue4Xi()
            
            print('=' *33)    
            print("\n (STEP 4A2 OF REASON4XI): CREATED QUEUE4XI ", time4xi())
            print('=' *33)           
            
            print(queue4xi)
            #<queue4xi.Queue4Xi object at 0x02DF9130>
             
            ack4queues = True 
            nack4queues = False
        except:
        
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
            print("\n (STEP 4A3 OF REASON4XI): *** FAILED TO CREATE QUEUE4XI *** ", time4xi())
                
        return
    else:
        print("\n REASON4XI: CONSIDERED DONE STEP4A ", time4xi())
        
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
 
    if step == "STEP4B":                        
        # ---------------------------------------------------------------------------------------------
        #(STEP 4B)
        # ---------------------------------------------------------------------------------------------
     
        print("\n (STEP 4B1 OF REASON4XI): CREATING PIPE4XI WITH CONSUMER AND PUBLISHER ENDS ", time4xi())
        ack4pipes = False
        nack4pipes = True
        try:
        
            # -----------------------------------------------------------------------------------------    
            # OK
            # -----------------------------------------------------------------------------------------     
                  
            pipe4xi_consumer_channel, pipe4xi_publisher_channel = Pipe4Xi()  # duplex default
            
            print("\n (STEP 4B2 OF REASON4XI) CREATED PIPE4XI_CONSUMER_CHANNEL ", time4xi())   
            print(pipe4xi_consumer_channel)
            #<read-write PipeConnection, handle 352>
            
            print("\n (STEP 4B3 OF REASON4XI) CREATED PIPE4XI_PUBLISHER_CHANNEL ", time4xi())  
            print(pipe4xi_publisher_channel)
            #<read-write PipeConnection, handle 272>
            
           
            print("\n (STEP 4B4 OF REASON4XI): CREATED PIPE4XI WITH CONSUMER AND PUBLISHER ENDS ", time4xi())
            
            ack4pipes = True
            nack4pipes = False
        except:
        
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
            print("\n (STEP 4B3 OF REASON4XI): *** FAILED TO CREATE PIPE4XI WITH CONSUMER AND PUBLISHER ENDS *** ", time4xi())
    
        return
    else:
        print("\n REASON4XI: CONSIDERED DONE STEP4B ", time4xi())
        
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
         
    if step == "STEP4C":    
        # ---------------------------------------------------------------------------------------------
        # (STEP 4C): 
        # ---------------------------------------------------------------------------------------------
       
        ack4process = False
        nack4process = True
        
        if ((ack4queues is True) and (ack4pipes is True)):
        
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
             
            print("\n (STEP 4C1 OF REASON4XI): CREATING PROCESS GIVING THE FUNCTION AND ITS ARGUMENTS STRING, QUEUE AND PIPE'S PUBLISHER END ", time4xi())
            
            print("\n (STEP 4C2 OF REASON4XI): PASSING QUEUE4XI to PROCESS4XI: ", queue4xi)
            # <queue4xi.Queue4Xi object at 0x02EA16B0>
            
            print("\n (STEP 4C3 OF REASON4XI): PASSING PIPE4XI_PUBLISHER_CHANNEL to PROCESS4XI: ", pipe4xi_publisher_channel)            
            # <read-write PipeConnection, handle 244>
            
            try:
       
                # -------------------------------------------------------------------------------------    
                # 
                # -------------------------------------------------------------------------------------     
                
                process4xi = Process4Xi(target=reason, args=('Energy ',queue4xi, pipe4xi_publisher_channel))
                
                print("\n (STEP 4C4 OF REASON4XI) CREATED PROCESS: ", str(process4xi))
                #<Process4Xi(Process4Xi-2, initial)>
                
                ack4process = True
                nack4process = False
            except:
       
                # -------------------------------------------------------------------------------------    
                #
                # -------------------------------------------------------------------------------------     
                
                print("\n (STEP 4C5 OF REASON4XI): *** FAILED TO CREATE PROCESS GIVING THE FUNCTION AND ITS ARGUMENTS STRING, QUEUE AND PIPE'S PUBLISHER END ", time4xi())
                   
        else:
        
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
             
            print("\n (STEP 4C6 OF REASON4XI): ** HAD TO SKIP CREATING PROCESS GIVING THE FUNCTION AND ITS ARGUMENTS STRING, QUEUE AND PIPE'S PUBLISHER END ** ", time4xi())
                
        return
    else:
        print("\n REASON4XI: CONSIDERED DONE STEP4C ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
 
    if step == "STEP4D":                          
        # ---------------------------------------------------------------------------------------------
        # STEP 4D:
        # ---------------------------------------------------------------------------------------------    
        ack4start = False
        nack4start = True    
        
        ack4run = False
        nack4run = True
            
        if ack4process is True:
    
               
            print("\n (STEP 4D1 OF REASON4XI): STARTING PROCESS PROCESS4XI GIVING THE FUNCTION AND ITS ARGUMENTS STRING, QUEUE AND PIPE PUBLISHER END ", time4xi())
    
            process4xi.start() 
            print("\n (STEP 4D2 OF REASON4XI) STARTED PROCESS: ", str(process4xi))
            #<Process4Xi(Process4Xi-2, stopped)>
            
            ack4start = True
            nack4start = False
            
            print("\n (STEP 4D3 OF REASON4XI) CALLING RUN PROCESS: ", str(process4xi))        
            #<Process4Xi(Process4Xi-2, stopped)>
            
            process4xi.run()
            
            print("\n (STEP 4D4 OF REASON4XI) PERFORMED RUN PROCESS: ", str(process4xi))
            # Energy
            # <queue4xi.Queue4Xi object at 0x02EA16B0> 
            # { Queue4Xi : put ; passed; object-passed-to-put-of-Queue4Xi: ['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']; time: 10:43:22 03/30/10 FLE Daylight Time}
            # { Queue4Xi : _start_thread ; (Step 1/9a) started; start-thread-of-Queue4Xi-started: ; time: 10:43:22 03/30/10 FLE Daylight Time}
            # <queue4xi.Queue4Xi object at 0x02EA16B0>
            # <read-write PipeConnection, handle 244>
            # { Queue4Xi : _feed ; (Step 8/9l) passing; object-passing-to-send-by-feed-of-Queue4Xi: ['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']; time: 10:43:22 03/30/10 FLE Daylight Time}
            # REASON: SENT DATA TO PIPE PUBLISHER CHANNEL END:  <read-write PipeConnection, handle 244>
            # REASON: REASONED TARGET:  Queue4Xi : _feedEnergy
            
            #(STEP 4D4) PERFORMED RUN PROCESS:
            # <Process4Xi(Process4Xi-2, stopped)>
             
            ack4run = True 
            nack4run = False       
             
        else:
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
               
            print("\n (STEP 4D5 OF REASON4XI): ** HAD TO SKIP STARTING PROCESS ** ", time4xi())

        return
    else:
        print("\n REASON4XI: CONSIDERED DONE STEP4D ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
                     
    if step == "STEP4E":        
        # ---------------------------------------------------------------------------------------------
        # STEP 4E:
        # ---------------------------------------------------------------------------------------------   
        ack4queue = False
        nack4queue = True
        
        count2try = 0
        
        while ((count2try < 9) and (ack4queue is False)):
        
            # -------------------------------------------------------------------------------------    
            # 
            # -------------------------------------------------------------------------------------     
            try:         
                print("\n (STEP 4E1 OF REASON4XI): GETTING FROM QUEUE  ", time4xi())
                #
                print (queue4xi.get())
                        
                print("\n (STEP 4E2 OF REASON4XI): GOT FROM QUEUE  ", time4xi())
                #{ Queue4Xi : get ; (Step 14/14b) returning; response-returning-by-get-of-Queue4Xi: ['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']; time: 10:43:22 03/30/10 FLE Daylight Time}
                #['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']
                # (STEP 4E2): GOT FROM QUEUE 
        
                ack4queue = True
                nack4queue = False 
                   
            except:
           
                # -------------------------------------------------------------------------------------    
                #
                # -------------------------------------------------------------------------------------     
     
                print("\n (STEP 4E3 OF REASON4XI): ** RE-TRIAL FROM QUEUE NEEDED **  ", time4xi())
                count2try = count2try + 1
                     
    
        return
    else:
        print("\n REASON4XI: CONSIDERED DONE STEP4E ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
         
    if step == "STEP4F":
                                
        # ---------------------------------------------------------------------------------------------
        # STEP 4F: 
        # ---------------------------------------------------------------------------------------------      
        print("\n (STEP 4F0 OF REASON4XI): CONTINUING ", time4xi()) 
        
    
        try: 
       
            # -------------------------------------------------------------------------------------    
            # 7 messages 
            # -------------------------------------------------------------------------------------     
                  
            print ("\n (STEP 4F1 OF REASON4XI): START RECEIVING FROM PIPE4XI ", time4xi())
            
            print (pipe4xi_consumer_channel.recv())
            print (pipe4xi_consumer_channel.recv())
            print (pipe4xi_consumer_channel.recv())
            print (pipe4xi_consumer_channel.recv())
            print (pipe4xi_consumer_channel.recv())
            print (pipe4xi_consumer_channel.recv())
            print (pipe4xi_consumer_channel.recv())
            

            print ("\n (STEP 4F2 OF REASON4XI): RECEIVED FROM PIPE4XI ", time4xi())
            #['DragonXi4_Reasoning_01', 'BIO ', 'Energy ']
            #['DragonXi4_Reasoning_02', 'Geo ', 'Energy ']
            #['DragonXi4_Reasoning_03', 'Hydrogen ', 'Energy ']

            
        except:
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
                
            print ("\n (STEP 4F3 OF REASON4XI): *** FAILED TO RECEIVE FROM PIPE4XI ", time4xi())
    
        return
    else:
        print("\n REASON4XI: CONSIDERED DONE STEP4F ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
      
    if step == "STEP4G":
                   
        # ---------------------------------------------------------------------------------------------
        # Steps 4G: 
        # ---------------------------------------------------------------------------------------------           
    
        print ("\n (STEP 4G1 OF REASON4XI) STARTING JOINING PROCESS ", time4xi())
            
        try:    
                                
            process4xi.join()
           
            print ("\n (STEP 4G2 OF REASON4XI) PERFORMED PROCESS JOIN ", time4xi())
            #
            
        except:
            print ("\n (STEP 4G3 OF REASON4XI) *** FAILED TO PERFORM PROCESS JOIN ", time4xi())    
            
        return
    else:
        print("\n REASON4XI: CONSIDERED DONE STEP4G ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
         
    if step == "STEP4H":    
        # ---------------------------------------------------------------------------------------------
        # Steps 4H: 
        # ---------------------------------------------------------------------------------------------           
    
        print ("\n (STEP 4H1 OF REASON4XI) STARTING TERMINATING PROCESS ", time4xi())
            
        try:    
                                
            process4xi.terminate()
           
            print ("\n (STEP 4H2 OF REASON4XI) TERMINATED PROCESS ", time4xi())
            #
            
        except:
            print ("\n (STEP 4H3 OF REASON4XI) *** FAILED TO TERMINATE PROCESS *** ", time4xi())
        
        return
    else:
        print("\n REASON4XI: CONSIDERED DONE STEP4H ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
     
    if step == "STEP4I":
                  
        # ---------------------------------------------------------------------------------------------
        # Steps 4I: 
        # ---------------------------------------------------------------------------------------------           
    
        print ("\n (STEP 4I1 OF REASON4XI) DELETING PROCESS OBJECT SKIPPED - TESTED ONCE - DELETES FROM NAMESPACE ", time4xi())
                     
        # del process4xi    
        
        print ("\n (STEP 4I3  OF REASON4XI DELETED PROCESS OBJECT SKIPPED - TESTED ONCE - DELETES FROM NAMESPACE ", time4xi())
        
        
        return
    else:
        print("\n REASON4XI: CONSIDERED DONE STEP4I ", time4xi())
            
    
    # =============================================================================================
    # (STEP 4J): REASONED IT!
    # =============================================================================================        
    print ("\n (STEP 4J1) REASONED IT! ", time4xi())   
    #
    # ---------------------------------------------------------------------------------------------     
    # initialize global variables back to their module values
    # --------------------------------------------------------------------------------------------- 
    
    # ---------------------------------------------------------------------------------------------     
    # common ones 
    # ---------------------------------------------------------------------------------------------                 
    ack4queues = False
    nack4queues = True
    
    ack4pipes = False
    nack4pipes = True
    
    ack4process = False
    nack4process = True
    
    ack4process = False
    nack4process = True
     
    ack4start = False
    nack4start = True   
     
    ack4run = False
    nack4run = True
   
    print ("\n (STEP 4J2 OF REASON4XI) INITIALIZED! ", time4xi())

    return

#</function4xi> 

# -----------------------------------------------------------------------------------------------------
#<function4xi function = "ace8xi" usage = "
#   ACE with Dragon4Xi multiprocessing
#">
# -----------------------------------------------------------------------------------------------------    
def ace8xi(step): 

    # -------------------------------------------------------------------------------------------------
    # common ones
    # -------------------------------------------------------------------------------------------------
    
    global ack4queues
    global nack4queues
    
    global ack4pipes
    global nack4pipes
    
    global ack4process
    global nack4process
    
    global ack4process
    global nack4process
    
    global ack4start
    global nack4start   
            
    global ack4run
    global nack4run

    # -------------------------------------------------------------------------------------------------
    # ace ones
    # -------------------------------------------------------------------------------------------------
    
    global queue8xi
    global pipe8xi_consumer_channel
    global pipe8xi_publisher_channel
    global process8xi    
    
    print("\n ACE8XI: RECEIVED STEP = ", step)
    print("\n ACE8XI: GLOBAL ack4queues = ", ack4queues)
    print("\n ACE8XI: GLOBAL nack4queues = ", nack4queues)
    print("\n ACE8XI: GLOBAL ack4pipes = ", ack4pipes)
    print("\n ACE8XI: GLOBAL nack4pipes = ", nack4pipes)    
    print("\n ACE8XI: GLOBAL ack4process = ", ack4process)
    print("\n ACE8XI: GLOBAL nack4process = ", nack4process)
    print("\n ACE8XI: GLOBAL ack4start = ", ack4start)
    print("\n ACE8XI: GLOBAL nack4start = ", nack4start)
    print("\n ACE8XI: GLOBAL ack4run = ", ack4run)
    print("\n ACE8XI: GLOBAL nack4run = ", nack4run)  
    
    print("\n ACE8XI: GLOBAL queue8xi = ", queue8xi) 
    print("\n ACE8XI: GLOBAL pipe8xi_consumer_channel = ", pipe8xi_consumer_channel)     
    print("\n ACE8XI: GLOBAL pipe8xi_publisher_channel = ", pipe8xi_publisher_channel)     
    print("\n ACE8XI: GLOBAL process8xi  = ", process8xi )     
    
    #
                                   
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
          
    if step == "STEP8A":
        # ---------------------------------------------------------------------------------------------
        # (STEP 8A)
        # ---------------------------------------------------------------------------------------------
        
        print("\n (STEP 8A OF ACE8XI): CREATING QUEUES8XI FOR ACEING ", time4xi())
        
        ack4queues = False
        nack4queues = True 
        try:
        
            # -----------------------------------------------------------------------------------------    
            #  (Step 8A):
            # -----------------------------------------------------------------------------------------     
            
            print('=' *33)    
            print("\n (STEP 8A1 OF ACE8XI): CREATING QUEUE8XI ", time4xi())
            print('=' *33)           
                 
            queue8xi = Queue4Xi()
            
            print('=' *33)    
            print("\n (STEP 8A2 OF ACE8XI): CREATED QUEUE8XI ", time4xi())
            print('=' *33)           
            
            print(queue8xi)
            #
             
            ack4queues = True 
            nack4queues = False
        except:
        
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
            print("\n (STEP 8A3 OF ACE8XI): *** FAILED TO CREATE QUEUE8XI *** ", time4xi())
                
        return
    else:
        print("\n ACE8XI: CONSIDERED DONE STEP8A ", time4xi())
        
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
 
    if step == "STEP8B":                        
        # ---------------------------------------------------------------------------------------------
        #(STEP 8B)
        # ---------------------------------------------------------------------------------------------
     
        print("\n (STEP 8B1 OF ACE8XI): CREATING PIPE8XI WITH CONSUMER AND PUBLISHER ENDS ", time4xi())
        ack4pipes = False
        nack4pipes = True
        try:
        
            # -----------------------------------------------------------------------------------------    
            # OK
            # -----------------------------------------------------------------------------------------     
                  
            pipe8xi_consumer_channel, pipe8xi_publisher_channel = Pipe4Xi()
            
            print("\n (STEP 8B2 OF ACE8XI) CREATED PIPE8XI_CONSUMER_CHANNEL ", time4xi())   
            print(pipe8xi_consumer_channel)
            #
            
            print("\n (STEP 8B3 OF ACE8XI) CREATED PIPE8XI_PUBLISHER_CHANNEL ", time4xi())  
            print(pipe8xi_publisher_channel)
            #
            
           
            print("\n (STEP 8B4 OF ACE8XI): CREATED PIPE8XI WITH CONSUMER AND PUBLISHER ENDS ", time4xi())
            
            ack4pipes = True
            nack4pipes = False
        except:
        
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
            print("\n (STEP 8B3): *** FAILED TO CREATE PIPE8XI WITH CONSUMER AND PUBLISHER ENDS *** ", time4xi())
    
        return
    else:
        print("\n ACE8XI: CONSIDERED DONE STEP8B ", time4xi())
        
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
         
    if step == "STEP8C":    
        # ---------------------------------------------------------------------------------------------
        # (STEP 8C): 
        # ---------------------------------------------------------------------------------------------
       
        ack4process = False
        nack4process = True
        
        if ((ack4queues is True) and (ack4pipes is True)):
        
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
             
            print("\n (STEP 8C1 OF ACE8XI): CREATING PROCESS GIVING THE FUNCTION AND ITS ARGUMENTS STRING, QUEUE AND PIPE'S PUBLISHER END ", time4xi())
            
            print("\n (STEP 8C2 OF ACE8XI): PASSING QUEUE8XI to PROCESS8XI: ", queue8xi)
            #
            
            print("\n (STEP 8C3 OF ACE8XI): PASSING PIPE8XI_PUBLISHER_CHANNEL to PROCESS4XI: ", pipe8xi_publisher_channel)            
            #
            
            try:
       
                # -------------------------------------------------------------------------------------    
                # 
                # -------------------------------------------------------------------------------------     
                
                process8xi = Process4Xi(target=ace, args=('Energy ',queue8xi, pipe8xi_publisher_channel))
                
                print("\n (STEP 8C4 OF ACE8XI) CREATED PROCESS: ", str(process8xi))
                #
                
                ack4process = True
                nack4process = False
            except:
       
                # -------------------------------------------------------------------------------------    
                #
                # -------------------------------------------------------------------------------------     
                
                print("\n (STEP 8C5 OF ACE8XI): *** FAILED TO CREATE PROCESS GIVING THE FUNCTION AND ITS ARGUMENTS STRING, QUEUE AND PIPE'S PUBLISHER END ", time4xi())
                   
        else:
        
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
             
            print("\n (STEP 8C6 OF ACE8XI): ** HAD TO SKIP CREATING PROCESS GIVING THE FUNCTION AND ITS ARGUMENTS STRING, QUEUE AND PIPE'S PUBLISHER END ** ", time4xi())
                
        return
    else:
        print("\n ACE8XI: CONSIDERED DONE STEP8C ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
 
    if step == "STEP8D":                          
        # ---------------------------------------------------------------------------------------------
        # STEP 8D:
        # ---------------------------------------------------------------------------------------------    
        ack4start = False
        nack4start = True    
        
        ack4run = False
        nack4run = True
            
        if ack4process is True:
    
               
            print("\n (STEP 8D1 OF ACE8XI): STARTING PROCESS PROCESS8XI GIVING THE FUNCTION AND ITS ARGUMENTS STRING, QUEUE AND PIPE PUBLISHER END ", time4xi())
    
            process8xi.start() 
            print("\n (STEP 8D2 OF ACE8XI) STARTED PROCESS: ", str(process8xi))
            #
            
            ack4start = True
            nack4start = False
            
            print("\n (STEP 8D3 OF ACE8XI) CALLING RUN PROCESS: ", str(process8xi))        
            #
            
            process8xi.run()
            
            print("\n (STEP 8D4 OF ACE8XI) PERFORMED RUN PROCESS: ", str(process8xi))
            #
            #
             
            ack4run = True 
            nack4run = False       
             
        else:
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
               
            print("\n (STEP 8D5 OF ACE8XI): ** HAD TO SKIP STARTING PROCESS ** ", time4xi())

        return
    else:
        print("\n ACE8XI: CONSIDERED DONE STEP8D ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
                     
    if step == "STEP8E":        
        # ---------------------------------------------------------------------------------------------
        # STEP 8E:
        # ---------------------------------------------------------------------------------------------   
        ack4queue = False
        nack4queue = True
        
        count2try = 0
        
        while ((count2try < 9) and (ack4queue is False)):
        
            # -------------------------------------------------------------------------------------    
            # 
            # -------------------------------------------------------------------------------------     
            try:         
                print("\n (STEP 8E1 OF ACE8XI): GETTING FROM QUEUE  ", time4xi())
                #
                print (queue8xi.get())
                        
                print("\n (STEP 8E2 OF ACE8XI): GOT FROM QUEUE  ", time4xi())
                #
        
                ack4queue = True
                nack4queue = False 
                   
            except:
           
                # -------------------------------------------------------------------------------------    
                #
                # -------------------------------------------------------------------------------------     
     
                print("\n (STEP 8E3 OF ACE8XI): ** RE-TRIAL FROM QUEUE NEEDED **  ", time4xi())
                count2try = count2try + 1
                     
    
        return
    else:
        print("\n ACE8XI: CONSIDERED DONE STEP8E ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
         
    if step == "STEP8F":
                                
        # ---------------------------------------------------------------------------------------------
        # STEP 8F: 
        # ---------------------------------------------------------------------------------------------      
        print("\n (STEP 8F0 OF ACE8XI): CONTINUING ", time4xi()) 
        
    
        try: 
       
            # -------------------------------------------------------------------------------------    
            # 5 messages 
            # -------------------------------------------------------------------------------------     
                  
            print ("\n (STEP 8F1 OF ACE8XI): START RECEIVING FROM PIPE8XI ", time4xi())
            
            print (pipe8xi_consumer_channel.recv())
            print (pipe8xi_consumer_channel.recv())
            print (pipe8xi_consumer_channel.recv())
            print (pipe8xi_consumer_channel.recv())
            print (pipe8xi_consumer_channel.recv())

            print ("\n (STEP 8F2 OF ACE8XI): RECEIVED FROM PIPE8XI ", time4xi())
            #

            
        except:
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
                
            print ("\n (STEP 8F3 OF ACE8XI): *** FAILED TO RECEIVE FROM PIPE8XI ", time4xi())
    
        return
    else:
        print("\n ACE8XI: CONSIDERED DONE STEP8F ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
      
    if step == "STEP8G":
                   
        # ---------------------------------------------------------------------------------------------
        # Steps 8G: 
        # ---------------------------------------------------------------------------------------------           
    
        print ("\n (STEP 8G1 OF ACE8XI) STARTING JOINING PROCESS ", time4xi())
            
        try:    
                                
            process8xi.join()
           
            print ("\n (STEP 8G2 OF ACE8XI) PERFORMED PROCESS JOIN ", time4xi())
            #
            
        except:
            print ("\n (STEP 8G3 OF ACE8XI) *** FAILED TO PERFORM PROCESS JOIN ", time4xi())    
            
        return
    else:
        print("\n ACE8XI: CONSIDERED DONE STEP8G ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
         
    if step == "STEP8H":    
        # ---------------------------------------------------------------------------------------------
        # Steps 8H: 
        # ---------------------------------------------------------------------------------------------           
    
        print ("\n (STEP 8H1 OF ACE8XI) STARTING TERMINATING PROCESS ", time4xi())
            
        try:    
                                
            process8xi.terminate()
           
            print ("\n (STEP 8H2 OF ACE8XI) TERMINATED PROCESS ", time4xi())
            #
            
        except:
            print ("\n (STEP 8H3 OF ACE8XI) *** FAILED TO TERMINATE PROCESS *** ", time4xi())
        
        return
    else:
        print("\n ACE8XI: CONSIDERED DONE STEP8H ", time4xi())    
    # -------------------------------------------------------------------------------------------------     
    #
    # -------------------------------------------------------------------------------------------------
     
    if step == "STEP8I":
                  
        # ---------------------------------------------------------------------------------------------
        # Steps 8I: 
        # ---------------------------------------------------------------------------------------------           
    
        print ("\n (STEP 8I1 OF ACE8XI) DELETING PROCESS OBJECT SKIPPED - TESTED ONCE - DELETES FROM NAMESPACE ", time4xi())
                     
        # del process8xi    
        
        print ("\n (STEP 8I3  OF ACE8XI) DELETED PROCESS OBJECT SKIPPED - TESTED ONCE - DELETES FROM NAMESPACE ", time4xi())
        
        
        return 
    else:
        print("\n ACE8XI: CONSIDERED DONE STEP8I ", time4xi())
            
    
    # =============================================================================================
    # (STEP 8J): ACEED IT!
    # =============================================================================================        
    print ("\n (STEP 8J1 OF ACE8XI) ACED IT! ", time4xi())   
    #
    # ---------------------------------------------------------------------------------------------     
    # initialize global variables back to their module values
    # --------------------------------------------------------------------------------------------- 
    
    # ---------------------------------------------------------------------------------------------     
    # common ones 
    # ---------------------------------------------------------------------------------------------                 
    ack4queues = False
    nack4queues = True
    
    ack4pipes = False
    nack4pipes = True
    
    ack4process = False
    nack4process = True
    
    ack4process = False
    nack4process = True
     
    ack4start = False
    nack4start = True   
     
    ack4run = False
    nack4run = True
   
    print ("\n (STEP 8J2 OF ACE8XI) INITIALIZED! ", time4xi())

    return

#</function4xi> 
                                    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "phase4" usage = "
#    testing with Dragon4Xi multiprocessing
#">
# -------------------------------------------------------------------------------------------------    
def phase4():     
    global t2xi
    global trace_object_count   
    
    # =========================================================================================
    # PHASE IV: USE DRAGON4XI MODULES
    # =========================================================================================
    print('=' *33)
    print("STARTING PHASE IV WITH DRAGON4XI MULTIPROCESSING MODULES ", time4xi())
    print('=' *33)

        
    # ----------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # -----------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1/33) OF TEST_PIPE1_MP_XI4 - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    # =========================================================================================
    # SENSE - OK
    # =========================================================================================
     
    try:

        # ------------------------------------------------------------------------------------- 
        # SETUP FOR SENSING - OK
        # -------------------------------------------------------------------------------------          
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP2A ", time4xi())
        # YES 
        
        sense4xi("STEP2A")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP2B ", time4xi())
        # YES         
        sense4xi("STEP2B")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED SETUP FOR SENSING ", time4xi())
        # YES
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED TO PERFORM SETUP FOR SENSING ***  ", time4xi())
  
    try:                        
        # ------------------------------------------------------------------------------------- 
        # SENSE 2 DRAGONXI - OK
        # -------------------------------------------------------------------------------------                   
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP2C ", time4xi())        
        # YES 
        sense4xi("STEP2C")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP2D ", time4xi())        
        # YES 
        sense4xi("STEP2D")                   
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP2E ", time4xi())        
        # YES 
        sense4xi("STEP2E")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP2F ", time4xi())        
        # YES 
        sense4xi("STEP2F")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED SENSING ", time4xi())
        # YES - 15 messages received:
        # ['DragonXi2_Sensing_01', 'BIO ', 'Energy ']
        # ['DragonXi2_Sensing_02', 'CO2 ', 'Energy ']
        # ['DragonXi2_Sensing_03', 'Coal ', 'Energy ']
        # ['DragonXi2_Sensing_04', 'Diesel ', 'Energy ']
        # ['DragonXi2_Sensing_05', 'Electricity ', 'Energy ']
        # ['DragonXi2_Sensing_06', 'Fusion ', 'Energy ']
        # ['DragonXi2_Sensing_07', 'Gas ', 'Energy ']
        # ['DragonXi2_Sensing_08', 'Geo ', 'Energy ']
        # ['DragonXi2_Sensing_09', 'Hydrogen ', 'Energy ']
        # 'DragonXi2_Sensing_10', 'Lithium ', 'Energy ']
        # ['DragonXi2_Sensing_11', 'Nuclear Power ', 'Energy ']
        # ['DragonXi2_Sensing_12', 'Ocean ', 'Energy ']
        # ['DragonXi2_Sensing_13', 'Oil ', 'Energy ']
        # ['DragonXi2_Sensing_14', 'Solar ', 'Energy ']
        # ['DragonXi2_Sensing_15', 'Wind ', 'Energy ']
  
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED TO PERFORM SENSING *** ", time4xi())
                
    
    # =========================================================================================
    # REASON - OK
    # =========================================================================================
                
    try:        
        # ------------------------------------------------------------------------------------- 
        # SETUP FOR REASONING - OK
        # -------------------------------------------------------------------------------------          
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP4A ", time4xi()) 
        # YES
         
        reason4xi("STEP4A")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP4B ", time4xi())        
        reason4xi("STEP4B")
        # YES 
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED SETUP FOR REASONING ", time4xi())
        #  (STEP 4B2) CREATED PIPE4XI_CONSUMER_CHANNEL
        #  <read-write PipeConnection, handle 240>
        #   (STEP 4B3) CREATED PIPE4XI_PUBLISHER_CHANNEL
        #  <read-write PipeConnection, handle 244>
        #   (STEP 4B4): CREATED PIPE4XI WITH CONSUMER AND PUBLISHER ENDS
          
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED TO PERFORM SETUP FOR REASONING *** ", time4xi())  
    
    try:      
        # ------------------------------------------------------------------------------------- 
        # REASON 4 DRAGONXI - OK
        # -------------------------------------------------------------------------------------                   
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP4C ", time4xi())        
        # YES
        reason4xi("STEP4C")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP4D ", time4xi())        
        # YES 
        
        reason4xi("STEP4D")                   
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP4E ", time4xi())        
        # YES 
        
        reason4xi("STEP4E")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP4F ", time4xi())        
        # YES 
        
        reason4xi("STEP4F")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED REASONING ", time4xi())
        # (STEP 4F1): START RECEIVING FROM PIPE4XI
        # ['DragonXi4_Reasoning_01', 'BIO ', 'Energy ']
        # ['DragonXi4_Reasoning_02', 'Geo ', 'Energy ']
        # ['DragonXi4_Reasoning_03', 'Hydrogen ', 'Energy ']
        # ['DragonXi4_Reasoning_04', 'Nuclear Power ', 'Energy ']
        # ['DragonXi4_Reasoning_05', 'Ocean ', 'Energy ']
        # ['DragonXi4_Reasoning_06', 'Solar ', 'Energy ']
        # ['DragonXi4_Reasoning_07', 'Wind ', 'Energy ']
  
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED TO PERFORM REASONING *** ", time4xi())     


    
    # =========================================================================================
    # FINISH SENSE - OK
    # =========================================================================================
      
    
    try:                                        
  
        # ------------------------------------------------------------------------------------- 
        # FINISH SENSING 2 DRAGONXI - OK
        # -------------------------------------------------------------------------------------           
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP2G ", time4xi())        
        sense4xi("STEP2G")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP2H ", time4xi())        
        sense4xi("STEP2H")   
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP2I ", time4xi())        
        sense4xi("STEP2I")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP2J ", time4xi())        
        sense4xi("STEP2J")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED FINISHING SENSING 2 DRAGONXI ", time4xi())
        # YES            
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED TO FINISH SENSING 2 DRAGONXI ***  ", time4xi()) 
    
    # =========================================================================================
    # FINISH REASON - OK
    # =========================================================================================
        
    try:          

        # ------------------------------------------------------------------------------------- 
        # FINISH REASONING 4 DRAGONXI - OK
        # -------------------------------------------------------------------------------------           
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP4G ", time4xi())        
        reason4xi("STEP4G")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP4H ", time4xi())        
        reason4xi("STEP4H")   
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP4I ", time4xi())        
        reason4xi("STEP4I")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP4J ", time4xi())        
        reason4xi("STEP4J")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED FINISHING REASONING 4 DRAGONXI ", time4xi())
        # YES    
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED TO FINISH REASONING 4 DRAGONXI ***  ", time4xi()) 
    
    
    # =========================================================================================
    # ACE - OK
    # =========================================================================================
            
    try:          
        # ------------------------------------------------------------------------------------- 
        # SETUP FOR ACING - OK
        # -------------------------------------------------------------------------------------          
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP8A ", time4xi()) 
        # 
    
        ace8xi("STEP8A")
        
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED STEP8A ", time4xi())
        #  (STEP 8A2): CREATED QUEUE8XI
        #  <queue4xi.Queue4Xi object at 0x030C7210>         
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED IN STEP8A *** ", time4xi())
            

    try:              
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP8B ", time4xi()) 
                           
        ace8xi("STEP8B")
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED STEP8B ", time4xi())
        # <read-write PipeConnection, handle 380>
        # (STEP 8B3) CREATED PIPE8XI_PUBLISHER_CHANNEL
        # <read-write PipeConnection, handle 384>              
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED IN STEP8B *** ", time4xi())

        
    try:      
        # ------------------------------------------------------------------------------------- 
        # ACE 8 DRAGONXI - OK
        # -------------------------------------------------------------------------------------                   
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP8C ", time4xi())        
        ace8xi("STEP8C")
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED STEP8C ", time4xi()) 
        #  (STEP 8C4) CREATED PROCESS:  <Process4Xi(Process4Xi-3, initial)>
                   
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED IN STEP8C *** ", time4xi())

    try:          
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP8D ", time4xi())        
        ace8xi("STEP8D")            
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED STEP8D ", time4xi()) 
        # (STEP 8D4) PERFORMED RUN PROCESS:  <Process4Xi(Process4Xi-3, stopped)>
                          
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED IN STEP8D *** ", time4xi())

    try:            
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP8E ", time4xi())        
        ace8xi("STEP8E")
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED STEP8E ", time4xi())
        # ['DragonXi8_00', 'Energy ', 'to be aced!']
        # (STEP 8E2): GOT FROM QUEUE 
        # PHASE4: PERFORMED STEP8E            
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED IN STEP8E *** ", time4xi())

    try:            
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP8F ", time4xi())        
        ace8xi("STEP8F")
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED STEP8F ", time4xi())
        #  (STEP 8F1): START RECEIVING FROM PIPE8XI
        # ['DragonXi8_Ace_01', 'BIO ', 'Energy ']
        # ['DragonXi8_Ace_02', 'Hydrogen ', 'Energy ']
        # ['DragonXi8_Ace_03', 'Nuclear Power ', 'Energy ']
        # ['DragonXi8_Ace_04', 'Solar ', 'Energy ']
        # ['DragonXi8_Ace_05', 'Wind ', 'Energy ']

        #  (STEP 8F2): RECEIVED FROM PIPE8XI
        # PHASE4: PERFORMED STEP8F                    
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED IN STEP8F *** ", time4xi())  
    
    # =========================================================================================
    # FINISH ACE - OK
    # =========================================================================================
              
    try:      
        # ------------------------------------------------------------------------------------- 
        # FINISH ACE 8 DRAGONXI
        # -------------------------------------------------------------------------------------           
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP8G ", time4xi())        
        ace8xi("STEP8G")
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED STEP8G ", time4xi())
        #  (STEP 8G2) PERFORMED PROCESS JOIN
        #  PHASE4: PERFORMED STEP8G    
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED IN STEP8G *** ", time4xi())  
    
    try:                
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP8H ", time4xi())        
        ace8xi("STEP8H")
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED STEP8H ", time4xi())
        #  (STEP 8H2) TERMINATED PROCESS
                   
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED IN STEP8H *** ", time4xi())  
    
    try:              
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP8I ", time4xi())        
        ace8xi("STEP8I")
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED STEP8I ", time4xi())
        # (STEP 8I3 DELETED PROCESS OBJECT SKIPPED - TESTED ONCE - DELETES FROM NAMESPACE           
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED IN STEP8I *** ", time4xi())  
    
    try:            
        print("PHASE4 OF TEST_PIPE1_MP_XI4: STARTING STEP8J ", time4xi())        
        ace8xi("STEP8J")
        print("PHASE4 OF TEST_PIPE1_MP_XI4: PERFORMED STEP8J ", time4xi())
        #  (STEP 8J1) ACED IT!
        #  (STEP 8J2) INITIALIZED!           
    except:
        print("PHASE4 OF TEST_PIPE1_MP_XI4: *** FAILED IN STEP8J ***  ", time4xi()) 
               
    finally:                
    
        # =====================================================================================   
        # PRINT TRACE
        # =====================================================================================    
        print_trace4xi(t2xi)            
#</function4xi>             
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   testing Pipe4Xi, Queue4Xi and Process4Xi
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#">     
# -------------------------------------------------------------------------------------------------  
def main():
    
    # =========================================================================
    # STANDARD MULTIPROCESSING PIPES
    # =========================================================================
    print('=' *33)
    print("(STEP 1A/3) OF TEST_PIPE1_MP_XI4 - STARTING PHASE 1!", time4xi())  
    print('=' *33)   
   
    phase1()

    print('=' *33)
    print("(STEP 1B/3) OF TEST_PIPE1_MP_XI4 - COMPELETED PHASE 1!", time4xi())  
    print('=' *33)   
    # =================================
    # STARTING PHASE 1 WITH ORIGINAL MULTIPROCESSING MODULES  00:15:50 01/09/13 Pacific Standard Time
    # =================================
    # ~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2
    # ['DragonXi2_00', 'Energy ', 'sensing!']
    # ['DragonXi2_Sensing_01', 'BIO ', 'Energy ']
    # ['DragonXi2_Sensing_02', 'CO2 ', 'Energy ']
    # ['DragonXi2_Sensing_03', 'Coal ', 'Energy ']
    # ['DragonXi2_Sensing_04', 'Diesel ', 'Energy ']
    # ['DragonXi2_Sensing_05', 'Electricity ', 'Energy ']
    # ['DragonXi2_Sensing_06', 'Fusion ', 'Energy ']
    # ['DragonXi2_Sensing_07', 'Gas ', 'Energy ']
    # ['DragonXi2_Sensing_08', 'Geo ', 'Energy ']
    # ['DragonXi2_Sensing_09', 'Hydrogen ', 'Energy ']
    # ['DragonXi2_Sensing_10', 'Lithium ', 'Energy ']
    # ['DragonXi2_Sensing_11', 'Nuclear Power ', 'Energy ']
    # ['DragonXi2_Sensing_12', 'Ocean ', 'Energy ']
    # ['DragonXi2_Sensing_13', 'Oil ', 'Energy ']
    # ['DragonXi2_Sensing_14', 'Solar ', 'Energy ']
    # ['DragonXi2_Sensing_15', 'Wind ', 'Energy ']
    # ~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4
    # ['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']
    # ['DragonXi4_Reasoning_01', 'BIO ', 'Energy ']
    # ['DragonXi4_Reasoning_02', 'Geo ', 'Energy ']
    # ['DragonXi4_Reasoning_03', 'Hydrogen ', 'Energy ']
    # ['DragonXi4_Reasoning_04', 'Nuclear Power ', 'Energy ']
    # ['DragonXi4_Reasoning_05', 'Ocean ', 'Energy ']
    # ['DragonXi4_Reasoning_06', 'Solar ', 'Energy ']
    # ['DragonXi4_Reasoning_07', 'Wind ', 'Energy ']
    # ~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8
    # ['DragonXi8_00', 'Energy ', 'to be aced!']
    # ['DragonXi8_Ace_01', 'BIO ', 'Energy ']
    # ['DragonXi8_Ace_02', 'Hydrogen ', 'Energy ']
    # ['DragonXi8_Ace_03', 'Nuclear Power ', 'Energy ']
    # ['DragonXi8_Ace_04', 'Solar ', 'Energy ']
    # ['DragonXi8_Ace_05', 'Wind ', 'Energy ']
    # =================================
    # COMPLETED PHASE 1 WITH ORIGINAL MULTIPROCESSING MODULES  00:15:51 01/09/13 Pacific Standard Time
    # =================================
    
    
        
    # =========================================================================
    # LAYERED MULTIPROCESSING PIPES
    # =========================================================================
    print('=' *33)
    print("(STEP 2A/3) OF TEST_PIPE1_MP_XI4 - STARTING PHASE 2!", time4xi())  
    print('=' *33)
               
    phase2()
    
    print('=' *33)
    print("(STEP 2B/3) OF TEST_PIPE1_MP_XI4 - COMPELETED PHASE 2!", time4xi())  
    print('=' *33) 
    # =================================
    # STARTING PHASE II WITH DRAGON2XI MULTIPROCESSING MODULES  00:15:51 01/09/13 Pacific Standard Time
    # =================================
    # 
    #  with yourDragonXi!  00:15:51 01/09/13 Pacific Standard Time
    # ['DragonXi2_00', 'Energy ', 'sensing!']
    # ['DragonXi2_Sensing_01', 'BIO ', 'Energy ']
    # ['DragonXi2_Sensing_02', 'CO2 ', 'Energy ']
    # ['DragonXi2_Sensing_03', 'Coal ', 'Energy ']
    # ['DragonXi2_Sensing_04', 'Diesel ', 'Energy ']
    # ['DragonXi2_Sensing_05', 'Electricity ', 'Energy ']
    # ['DragonXi2_Sensing_06', 'Fusion ', 'Energy ']
    # ['DragonXi2_Sensing_07', 'Gas ', 'Energy ']
    # ['DragonXi2_Sensing_08', 'Geo ', 'Energy ']
    # ['DragonXi2_Sensing_09', 'Hydrogen ', 'Energy ']
    # ['DragonXi2_Sensing_10', 'Lithium ', 'Energy ']
    # ['DragonXi2_Sensing_11', 'Nuclear Power ', 'Energy ']
    # ['DragonXi2_Sensing_12', 'Ocean ', 'Energy ']
    # ['DragonXi2_Sensing_13', 'Oil ', 'Energy ']
    # ['DragonXi2_Sensing_14', 'Solar ', 'Energy ']
    # ['DragonXi2_Sensing_15', 'Wind ', 'Energy ']
    # 
    #  with yourDragonXi!  00:15:52 01/09/13 Pacific Standard Time
    # ['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']
    # ['DragonXi4_Reasoning_01', 'BIO ', 'Energy ']
    # ['DragonXi4_Reasoning_02', 'Geo ', 'Energy ']
    # ['DragonXi4_Reasoning_03', 'Hydrogen ', 'Energy ']
    # ['DragonXi4_Reasoning_04', 'Nuclear Power ', 'Energy ']
    # ['DragonXi4_Reasoning_05', 'Ocean ', 'Energy ']
    # ['DragonXi4_Reasoning_06', 'Solar ', 'Energy ']
    # ['DragonXi4_Reasoning_07', 'Wind ', 'Energy ']
    # 
    #  with yourDragonXi!  00:15:52 01/09/13 Pacific Standard Time
    # ['DragonXi8_00', 'Energy ', 'to be aced!']
    # ['DragonXi8_Ace_01', 'BIO ', 'Energy ']
    # ['DragonXi8_Ace_02', 'Hydrogen ', 'Energy ']
    # ['DragonXi8_Ace_03', 'Nuclear Power ', 'Energy ']
    # ['DragonXi8_Ace_04', 'Solar ', 'Energy ']
    # ['DragonXi8_Ace_05', 'Wind ', 'Energy ']
    # =================================
    # COMPLETED PHASE II WITH DRAGON2XI MULTIPROCESSING MODULES  00:15:52 01/09/13 Pacific Standard Time
    # =================================
    
        
    # =========================================================================
    # DRAGONIZED MULTIPROCESSING PIPES
    # ========================================================================= 
    print('=' *33)
    print("(STEP 3A/3) OF TEST_PIPE1_MP_XI4 - STARTING PHASE 4!", time4xi())  
    print('=' *33)    
    phase4()
    print('=' *33)
    print("(STEP 3B/3) OF TEST_PIPE1_MP_XI4 - COMPELETED PHASE 4!", time4xi())  
    print('=' *33)      
    # =================================
    # { Queue4Xi : get ; (Step 14/14b) returning; response-returning-by-get-of-Queue4Xi: ['DragonXi2_00', 'Energy ', 'sensing!']; time: 00:15:53 01/09/13 Pacific Standard Time}
    # =================================
    # ['DragonXi2_00', 'Energy ', 'sensing!']
    # (STEP 2E2 OF SENSE4XI): GOT FROM QUEUE   00:15:53 01/09/13 Pacific Standard Time
    # ['DragonXi2_Sensing_01', 'BIO ', 'Energy ']
    # ['DragonXi2_Sensing_02', 'CO2 ', 'Energy ']
    # ['DragonXi2_Sensing_03', 'Coal ', 'Energy ']
    # ['DragonXi2_Sensing_04', 'Diesel ', 'Energy ']
    # ['DragonXi2_Sensing_05', 'Electricity ', 'Energy ']
    # ['DragonXi2_Sensing_06', 'Fusion ', 'Energy ']
    # ['DragonXi2_Sensing_07', 'Gas ', 'Energy ']
    # ['DragonXi2_Sensing_08', 'Geo ', 'Energy ']
    # ['DragonXi2_Sensing_09', 'Hydrogen ', 'Energy ']
    # ['DragonXi2_Sensing_10', 'Lithium ', 'Energy ']
    # ['DragonXi2_Sensing_11', 'Nuclear Power ', 'Energy ']
    # ['DragonXi2_Sensing_12', 'Ocean ', 'Energy ']
    # ['DragonXi2_Sensing_13', 'Oil ', 'Energy ']
    # ['DragonXi2_Sensing_14', 'Solar ', 'Energy ']
    # ['DragonXi2_Sensing_15', 'Wind ', 'Energy ']    
    # 
    # ['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']
    # ['DragonXi4_Reasoning_01', 'BIO ', 'Energy ']
    # ['DragonXi4_Reasoning_02', 'Geo ', 'Energy ']
    # ['DragonXi4_Reasoning_03', 'Hydrogen ', 'Energy ']
    # ['DragonXi4_Reasoning_04', 'Nuclear Power ', 'Energy ']
    # ['DragonXi4_Reasoning_05', 'Ocean ', 'Energy ']
    # ['DragonXi4_Reasoning_06', 'Solar ', 'Energy ']
    # ['DragonXi4_Reasoning_07', 'Wind ', 'Energy ']    
    # 
    # ['DragonXi8_00', 'Energy ', 'to be aced!']
    # ['DragonXi8_Ace_01', 'BIO ', 'Energy ']
    # ['DragonXi8_Ace_02', 'Hydrogen ', 'Energy ']
    # ['DragonXi8_Ace_03', 'Nuclear Power ', 'Energy ']
    # ['DragonXi8_Ace_04', 'Solar ', 'Energy ']
    # ['DragonXi8_Ace_05', 'Wind ', 'Energy ']                

#</function4xi> 

            

if __name__ == '__main__':
    main()
#</function4xi>   

    
#</program4xi>
 
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_pipe1_mp_xi4.txt
#   sense-pipe1-test4xi.xml
#   reason-pipe1-test4xi.xml
#   ace-pipe1-test4xi.xml

#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_pipe2_mp_xi4.py                            
# ------------------------------------------------------------------------------------------------- 
#"
